Subject: RE:

From: Shahram Davari <[email-masked]>
Date: Mon, 29 Apr 2002 06:36:17 -0700

The reason that a placeholder label entry is required is that
the ATM header doesn't have any field to tell you whether there is any MPLS
label underneath the ATM header. The S-bit of the placeholder label will
do this job.

As you said in normal MPLS forwarding label 0 is interpreted as explicit null label,
but in ATM-LSRs, after the packet has been reassembled from the ATM cells, it is 
understood that for forwarding purpose the value of the top label is equal 
to VPI/VCI not 0.

So for VPN purpose, you should encode your tunnel label in the VPI/VCI, then set
the top shim entry to zero and set the bottom label to VC label.

-Shahram

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]
> Sent: Saturday, April 27, 2002 5:12 AM
> To: [email-masked]
> Subject: 
> 
> 
> 
> 
> How to deal with MPLS VPN forwarding on ATM LSR ?
> 
> 
>    in rfc3035,states "Except in certain circumstances specified below,
>      when a labeled packet is transmitted on an LC-ATM interface,
>      where the VPI/VCI (or VCID) is interpreted as the top label
>      in the label stack, the packet MUST also contain a 'shim 
> header' [3].
>      If the packet has a label stack with n entries, it MUST 
> carry a shim
>      with n entries.  The actual value of the top label is 
> encoded in the
>      VPI/VCI field.  The label value of the top entry in the 
> shim (which
>      is just a 'placeholder' entry) MUST be set to 0 upon 
> transmission,
>      and MUST be ignored upon reception.  The packet's 
> outgoing TTL, and
>      its CoS, are carried in the TTL and CoS fields 
> respectively of the
>      top stack entry in the shim."
> 
>    So it means that if the packet has a label stack with n 
> entries, the top
>    entry in the shim is 0. When I send a VPN packet on an ATM 
> ingress, I
> put
>    VPN internal label in the shim label stack bottom 
> entry,then out label
> is vpi/vci,
>    I should put 0 in the shim label stack top entry;
> 
>    but this conflict with the following section:
> 
>    in RFC3032 states "A value of 0 represents the IPv4 
> Explicit NULL Label,
>      This label value is only legal at the bottom of the label stack"
> 
>    What should I do on ATM LSR to support VPN ?
>